structure Satrak :> Satrak =
    (* Az albbi satrak fggvny megoldja az olyan feladatokat, amelyekben csak
       *** egyetlen *** fa van a kertben.  
       Satrak.sml --- V1.2 -- 2001. mjus 8. -- Hank Pter
    *)
struct

(* satrak(Ss, Os, Fs) = a kertben egy stor egyetlen Fs-beli fhoz
         viszonytott sszes lehetsges helyzett ler listk listja 
   val satrak : TSatrak.fLeiro -> TSatrak.sHelyek list
*)
fun satrak (Ss, Os, [(sFa, oFa)]) = 
      let
	  val sorokSzama = length Ss
          val oszlopokSzama = length Os

          (* satrak0 b i zs = a straknak a fhoz viszonytott helyzett ler zs lista,
                              amely storhelynek alkalmas parcella (azaz a b igaz volta)
                              esetn a megfelel i irnnyal ki van egsztve
	     satrak0 : bool -> TSatrak.sHelyek -> TSatrak.sHelyek list
          *)
          fun satrak0 b i zs = if b then i::zs else zs

          (* A kertben elhelyezhet straknak a fhoz viszonytott helyzett ler, ngy
          lpsben ellltott listja ps3
          *)
          val ps0 = satrak0 (sFa > 1 andalso 
                            List.nth(Ss, sFa-2) * List.nth(Os, oFa-1) <> 0) [TSatrak.n] []
          val ps1 = satrak0 (oFa > 1 andalso 
                            List.nth(Ss, sFa-1) * List.nth(Os, oFa-2) <> 0) [TSatrak.w] ps0
          val ps2 = satrak0 (sFa < sorokSzama andalso 
                            List.nth(Ss, sFa) * List.nth(Os, oFa-1) <> 0) [TSatrak.s] ps1
          val ps3 = satrak0 (oFa < oszlopokSzama andalso
                            List.nth(Ss, sFa-1) * List.nth(Os, oFa) <> 0) [TSatrak.e] ps2
      in
          rev ps3
      end
  | satrak (Ss, Os, _) = [] (* nem pontosan egy fa van a kertben *)

end;
