(* Pldk a keretprogram hasznlatra
   egySator.sml -- V1.2 -- 2001. mjus 8. -- Hank Pter
*)

(* A Satrak.sml struktra-modult pl. a compile fggvny alkalmazsval fordthatjuk le.
   FONTOS: a tpusdefincikat tartalmaz TStarak.sml struktra-modult s a Satrak.sig
   szignatra-modult elzleg ehhez hasonlan le kellett fordtani (a *.ui s *.uo
   llomnyok platformfggek!); a Satrak.sml fordtsakor a TSatrak.ui, a TSatrak.uo s a
   Satrak.ui llomnyoknak mr a Satrak.sml llomnnyal egy knyvtrban kell lennik.
*)

compile "Satrak.sml";

(* A keretprogram KSatrak.sig szignatra- s KSatrak.sml struktra-moduljainak lefordtott
   vltozatban (KSatrak.ui, KSatrak.uo) ugyancsak lteznik kell mr, amikor a
   keretprogramot hasznlni akarjuk. Az interaktv mosml-krnyezetben a load fggvnnyel a
   keretprogramot is be kell tlteni a hasznlat eltt.
*)

load "KSatrak";

(* Emlkeztetl a fejkommentek a KSatrak.sig llomnybl: *)

(* satrak_be f = az f szveges llomnybl beolvasott adatokbl kpzett feladvnyler
   val satrak_be : string -> TSatrak.fLeiro
*)

(* satrak_ki(m, sss, fl) = az sss megoldslista s az fl feladvnyler
      alapjn az sszes megoldst kirja az m szveges llomnyba
   val satrak_ki : string * TSatrak.fLeiro * TSatrak.sHelyek list -> unit
*)

(* megold(f, m) = beolvas egy feladvnyt az f szveges llomnybl s kirja
      az sszes megoldst az m szveges llomnyba; ehhez szksge van a
      Satrak.satrak fggvnyre; eredmnye az f nevet, a megoldsok szmt s a
      futsi idt mp-ben tartalmaz fzr
   val megold : string * string -> string
*)

(* Plda a Satrak.satrak fggvny alkalmazsra *)

Satrak.satrak([0,~1,~1], [0,~1,~1,0], [(2,2)]);

(* Most a keretprogram hrom fggvnynek alkalmazsra mutatunk pldkat.  A
   KSatrak.satrak_be beolvassa a feladvnyt az allomnybl, s a megfelel TSatrak.fLeiro
   tpus feladvnylert adja eredmnyl.
*)

val sss = KSatrak.satrak_be("1Tesztd0.txt");

(* Satrak.satrak a feladvnyler alapjn ellltja az sszes megolds listjt.
*)

val ms = Satrak.satrak sss;

(* KSatrak.satrak_ki kirajzolja a megoldsokat a kpernyre
*) 

KSatrak.satrak_ki("/dev/stdout", sss, ms);

(* KSatrak.megold az elz hrom lpst egyszerre vgrehajtja; s eredmnyl adja a
   megoldsok szmt s vgrehajtsi idt tartalmaz fzrt.
*)

KSatrak.megold("1Tesztd0.txt", "/dev/stdout");

(* A print az eredmnyl kapott fzrt is kirja a kpernyre
*)

print(KSatrak.megold("1Tesztd0.txt", "/dev/stdout"));
